<?php

namespace Drupal\content_snapshot\Compiler;

use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Reference;

class ContentSnapshotExtensionPass implements CompilerPassInterface {

  /**
   * {@inheritdoc}
   *
   * @throws \Exception
   */
  public function process(ContainerBuilder $container) {

    if ($container->hasDefinition('pathauto.generator')) {
      $pathItemNormalizerDefinition = $container->getDefinition('content_snapshot.normalizer.field_item.path_item');
      $pathItemNormalizerDefinition->addMethodCall('setPathautoGenerator', [new Reference('pathauto.generator')]);
    }

  }

}
