<?php

/**
 * @file
 */

namespace Drupal\content_snapshot\Logger;

/**
 * Class Logger.
 */
class Logger implements LoggerInterface {


  /**
   * @var \Psr\Log\LoggerInterface
   */
  private $logger;

  /**
   * @param \Psr\Log\LoggerInterface $logger
   */
  public function setLogger(\Psr\Log\LoggerInterface $logger): void {
    $this->logger = $logger;
  }

  public function emergency($message, array $context = []) {
    $this->logger->emergency($message, $context);
  }

  public function alert($message, array $context = []) {
    $this->logger->alert($message, $context);
  }

  public function critical($message, array $context = []) {
    $this->logger->critical($message, $context);
  }

  public function error($message, array $context = []) {
    $this->logger->error($message, $context);
  }

  public function warning($message, array $context = []) {
    $this->logger->warning($message, $context);
  }

  public function notice($message, array $context = []) {
    $this->logger->notice($message, $context);
  }

  public function info($message, array $context = []) {
    $this->logger->info($message, $context);
  }

  public function debug($message, array $context = []) {
    $this->logger->debug($message, $context);
  }

  public function log($level, $message, array $context = []) {
    $this->logger->log($level, $message, $context);
  }

}
