<?php

/**
 * @file
 */

namespace Drupal\content_snapshot\Normalizer\paragraphs;

use Drupal\content_snapshot\Normalizer\ContentEntityNormalizer;
use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\paragraphs\ParagraphInterface;

/**
 * Class ParagraphNormalizer
 */
class ParagraphNormalizer extends ContentEntityNormalizer {

  /**
   * {@inheritdoc}
   */
  protected $supportedInterfaceOrClass = ParagraphInterface::class;

  /**
   * {@inheritdoc}
   *
   * @param $entity ContentEntityInterface
   */
  public function normalize($entity, $format = NULL, array $context = []) {

    $normalized = parent::normalize($entity, $format, $context);

    $this->cleanupNormalization($normalized, $entity);


    return $normalized;
  }

  /**
   * @param array $attributes
   * @param \Drupal\Core\Entity\ContentEntityInterface $contentEntity
   */
  private function cleanupNormalization(array &$attributes, ContentEntityInterface $contentEntity): void {
    // These values are not needed in the snapshot, and will be correctly set during import.
    unset($attributes['parent_id']);
    unset($attributes['parent_type']);
  }
}
